from django.shortcuts import render
from django.http import HttpResponse, HttpResponseRedirect
from .models import TriggerLog
from django.utils import timezone
from django.urls import reverse
from django.conf import settings

## import modules for RPi/relay control
import RPi.GPIO as GPIO
import time

sensorpin = settings.RPI_SENSOR_PIN
relaypin = settings.RPI_RELAY_PIN
allowedIPs = settings.IP_WHITELIST_DOORCONTROL
GPIO.setwarnings(False)
GPIO.setmode(GPIO.BOARD)
GPIO.setup(relaypin, GPIO.OUT)
GPIO.setup(sensorpin, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
def actuateDoor(request):
    ip = request.META.get('HTTP_X_FORWARDED_FOR', request.META.get('REMOTE_ADDR', '')).split(',')[0].strip()

    if ip in allowedIPs:
        GPIO.output(relaypin, GPIO.HIGH)
        time.sleep(.5)
        GPIO.output(relaypin, GPIO.LOW)
        q = TriggerLog(user='anonymous', logTime=timezone.now(), ip=ip, triggerSuccess=True)
        q.save()
    else:
        q = TriggerLog(user='anonymous', logTime=timezone.now(), ip=ip, triggerSuccess=False)
        q.save()
#    return render(request, 'door_control/results.html')
    return HttpResponseRedirect(reverse('door_control:index'))

def index(request):
    status = ''
    if GPIO.input(sensorpin) == GPIO.HIGH:
        status = 'open'
    else:
        status = 'closed'
    latest_logs = TriggerLog.objects.order_by('-logTime')[:5]
    return render(request, 'door_control/index.html', {'status':status, 'latest_logs':latest_logs})
